{Auteur :Martin Beaudet
  Page Web :Http://www.altern.org/eraquila
}
unit Utils;

interface
uses
  Windows, StdCtrls;

{------------------------------------------------------------------------------}
{                 Procdures, fonctions et variables globales                  }
{------------------------------------------------------------------------------}
 {Trouver toutes le fentre qui seront utilises}
  Procedure TrouverFenetre;

 {Fonction servant  trouver le Handle d'une fentre Mre}
  Function TrouveFenetreMere ( TitreDeLaFenetre :PChar;
                               NomDeLaFenetre :PChar ) :Word;

 {Fonction servant  trouver le Handle d'une fentre Fille}
  Function TrouveFenetreFille ( AddresseFenetreMere :Word;
                                NomDeLaFenetreFille :PChar ) :Word;

 {Afficher ou cacher la fentre par son Handle reu en paramtre}
  Procedure CacherFenetre ( Addr :Word );
  Procedure AfficherFenetre ( Addr :Word );

Var
 {Variables de type Handle toutes utilises pour rcupr un certain Handle}
   Progman,         { '|                                                      }
   Shelldll,        { '|                                                      }
   Syslist,         { '|--> Les Composantes Utilises Du Desktop De Windows   }
   Sysheader,       { '|                                                      }
   Desktop,         { '|                                                      }
   Shelltray,       { '|                                                      }
   Bouton,          {  '|                                                     }
   Rebarwindow,     {  '|                                                     }
   Mtask,           {  '|---> Les Composantes Utilises De La Barre Des Tches}
   SysPager,        {  '|     De Windows                                      }
   Toolbar,         {  '|                                                     }
   SysTabControl,   {  '|                                                     }
   Traynotify :Word;{  '|                                                     }
{-----------------------------------------------------------------------------}
implementation


Procedure TrouverFenetre;

{Objectif :Rcuprer dans les variables globales dclarer ci-haut, toutes les
           fentres qui seront cacher ou afficher...}

Begin
{Tout D'Abord Il Faut Trouver Le  (Le Bureau Et Les Icne) }
    Progman   := TrouveFenetreMere ( 'Progman', 'Program Manager' );
    Shelldll  := TrouveFenetreFille ( Progman, 'SHELLDLL_DefView' );
    Syslist   := TrouveFenetreFille ( Shelldll, 'SysListView32' );
    Sysheader := TrouveFenetreFille ( Syslist, 'SysHeader32' );
    Desktop   := GetDesktopWindow;

{Ensuite Trouver Tout Ce Qui Se trouve Sur La Bar Des Tche}
    Shelltray     := TrouveFenetreMere ( 'Shell_TrayWnd', '');
    Bouton        := TrouveFenetreFille ( Shelltray, 'Button' );
    Rebarwindow   := TrouveFenetreFille ( Shelltray, 'ReBarWindow32' );
    Mtask         := TrouveFenetreFille ( Rebarwindow, 'MSTaskSwWClass' );
    SysPager      := TrouveFenetreFille ( Rebarwindow, 'SysPager' );
    Toolbar       := TrouveFenetreFille ( SysPager, 'ToolbarWindow32' );
    SysTabControl := TrouveFenetreFille ( Mtask, 'SysTabControl32' );
    TrayNotify    := TrouveFenetreFille ( Shelltray, 'TrayNotifyWnd' );

End;

Function TrouveFenetreMere ( TitreDeLaFenetre :PChar;
                             NomDeLaFenetre :PChar) :Word;

{Objectif : l'aide du titre et du nom de la fentre pass en paramtre, trouver
           et retourner le Handle de la fentre trouver....}

Begin
     TrouveFenetreMere := FindWindow ( TitreDeLaFenetre, NomDeLaFenetre );
End;


Function TrouveFenetreFille ( AddresseFenetreMere :Word;
                              NomDeLaFenetreFille :PChar ) :Word;

{Objectif : l'aide du titre et du nom de la fentre mre pass en paramtre,
           trouver et retourner le Handle d'une des ses fentres fille....}

Begin
     TrouveFenetreFille := FindWindowEx ( AddresseFenetreMere, $0,
                                          NomDeLaFenetreFille, '')
End;

Procedure CacherFenetre ( Addr :Word );

{Objectif :Cacher la fentre possdant le Handle reu en paramtre}

Begin
     ShowWindow ( Addr, SW_HIDE );
End;

Procedure AfficherFenetre ( Addr :Word );

{Objectif :Rafficher la fentre possdant le Handle reu en paramtre}

Begin
     ShowWindow ( Addr, SW_SHOW );
End;

end.
